%:fil CMPLX.SL  	Complex conjugation; general objects

% (CMPLX SXP) returns the complex conjugate of SXP, without destroying SXP.
% (RPLCONJ A B) Z Y puts complex conjugate of A on Z, and of Z (since atom)
% to A etc.	If user forgot to decl. c.c. of an object, it is asked for.
% Answer Y and N(or other non-blanc/cr) to questions.

% grep finds this file first (since .sl) so here headers for grep-made files:
%%:err:fil STSERR.HLP	Stensor Errors. Sacred! (System read)
%%:war:fil STSWAR.HLP	Stensor Warnings. Sacred! (System read)
%%:e:fil STSERX.HLP	Stensor Error eXplanations.
%%:w:fil STSWAX.HLP	Stensor Warning eXplanations.

%%:msg:fil STSMSG.HLP	Stensor Messages. Sacred! (System read)
%  %:nsw:fil SWITCH.HLP	Stensor Switches. Sacred! (System read)

(IFP (NOT(GETD 'CHASK))	% *** Conditionally **:
  (CPROGN
   (LOAD BASMAC)	% Some basic macros and functions:
   (LOAD BASFUN)		% Return x if nonblanc:
   (DE REABP (X) (IFPE (OR (EQ 32 X) (GREATERP 14 X)) NIL X))
   (DE REABL (Y) (COND ((REABP Y) Y) ((REABL (TYI)))))
   (DE CHASK (A B)	% ^reads thru bl untl nonbl ch. Return it
    (PROG2
     (PROGN  (PRINCS A)  (PRIN2 B)  (SETQ !*DDTIN T))
     (ERRSET (INTERN (ASCII (REABL (TYI)))) T)
     (SETQ !*DDTIN NIL) ))
   (DE YASK (A B) (EQ 'Y (CAR (CHASK A B))))	))	% ***end cond

(NEWSWITCHES (
SYMCX	"If conj of SYM unknown:create SYMX,printing with *")) %:nsw

%(DF AND1F (L!*) (PROG (P!*)	%:b Fexpr form of AND1. Evals only if nonnil
%  (OR (SETQ P!* (EVAL (CAR L!*))) (RETURN))	% Store 1:st evaled arg
%L (OR (SETQ L!* (CDR L!*)) (RETURN P!*))	% No more args: Return 1:st
%  (AND (EVAL (CAR L!*)) (GO L))  ))		% If Nxt arg nonnil, loop

(GLOBAL '(CONJLIST!*))
(DE PUTC1 (X Y) (PROG1 (PUT X 'CONJ Y) (PUSHQ CONJLIST!* X)))

(DE PUTC2 (A B) (COND	% A = (SPNR 3) sets spnr hermitian in ix 3 and 4
  ((ATOM A) (AND (ATOM (PUTC1 A B))
		 (PUTC1 B A))	% If B also atom, put on it too, A as conj.
	    A)			% Return A
  (T	(PUTPROPL (LIST B (CAR A)) (CDR A) 'CXREV)
	(PUTC2 (CAR A) B) ) ))

(FLUID '(L!* X!*))
(DE MAPUTC2 (DO) (MAPCAR L!* (FUNCTION (LAMBDA (X!*) (PUTC2 X!* (EVAL DO)))) ))
					   % Below are 6 minimized codesizes:
(DF REAL (L!*) (MAPUTC2 'X!*))		   %:h (REAL A B C...) declares all the
(DF IMAGINARY (L!*) (MAPUTC2 '(MKMIN X!*))) %:h	-symbols to be real, imaginary,
(DF UNITARY (L!*) (MAPUTC2 '(LIST 'EXPT X!* -1)))    %:h  -unitary, or arbi-
(DF COMPLEX (L!*) (MAPUTC2 '(ADXN!* X!*)))	     %:h trary. Make new Object
				% -else turn on SYMCX for default arbitrary.
(DF PUTCX (L!*) (MAPUTC2 '(READ)))		%:old	(PUTCX A B)   AX  BX
(DF RPLCONJ (L!*) (MAPUTC2 '(FOIN)))		%:h	(RPLCONJ A B) AX$ BX$

(DF SETCONJ (L) (MAPAIR L 'PUTC2)) %:h (SETCONJ A AX B BX..) sets CONJ(A)=AX,..

(DE MAPAIR (L FN2) %:b Apply a 2argfn on two L-elements at a time. Err If L Odd
 (PROG (A)
L (OR L (RETURN A))			% Quit if no more pairs
  (OR (CDR L) (STERROR			% Err if odd nbr of elements:
708 "%p made nbr of args odd - should be even"	%:err
			(CAR L) ))
  (SETQ A (NCONC1 A (FUNCALL FN2 (CAR L) (CADR L))))% Apply on the two elements
  (SETQ L (CDDR L))				% strip off pair of elements
  (GO L) ))

%:e	Some function that wants an *even* number of arguments (eg SETCONJ),
%:e	was erraneously given an *odd* number, due to this last argument.#
%:e

(OR (BOUNDP 'PLU!*) (AND (SETQ PLU!* 'PLUS) (SETQ TIM!* 'TIMES)))
(OR (BOUNDP 'EXP!*) (SETQ EXP!* 'EXPT))

(EVAL (CONS 'REAL (LIST PLU!* TIM!* EXP!*))) % To get symbols for &+ * ^

%(PUTCX I)	(* -1 I)	% Imag unit, but use below to grab *-indicator
(PUTC2 'I (LIST TIM!* -1 'I))
(REAL EXP)	% Base of natural log

"CX of symbols +*^ were set in CMPLX.STS"

(DE CXASK (Z) 
 (COND ((YASK Z "real?") Z) ((PRIN2 " type cmplx c.") (READ))))

(DE ADXN!* (Z) % After the symbol Z, ad "X" to form conj. Make Name have *
 (PROGN
  (PUT (SETQ !*ELEMPOS (INTERN(COMPRESS(NCONC1(EXPLODE Z) 'X))))% Save new obj.
       'NAM
       (NCONS (CONS (OR (GET Z 'NAM) Z) '(!/!/ !* !/!*))) )	% Code-share
  !*ELEMPOS) )		% Return new object

(DE CX!?N!* (Z) (OR	% Cmplx-Ask?, or setup Nam-star
  (AND (NOT SYMCX) (YASK Z "cmplx c. known?") (SETQ !*ELEMPOS (CXASK Z)))
  (ADXN!* Z) ))

(FLUID '(SXP!*))

(PUT 'CONJ 'SHSMPFN (LAMBDAX (CMPLX (CADR X))))
(PUT 'ABS 'SHSMPFN (LAMBDAX (SHABS (CADR X))))
(COMPOPERATOR ABS)
(PUT 'ABS 'CMPOP '(CONS 'SHABS (CDR PAIR!*)))	% Create (ABS (TN A B))

(DE SHABS (X) (MKEXPT (DOMULC X (CMPLX X)) HALF!*))

(DE CMPLX (SXP!*)		% COMPLeX Conjugate a general (Shp?)-expression
 (COND
   ((ATOM SXP!*)		% The fluid SXP* is used in eg CXREV,CXTSR
    (OR (AND (NUMBERP SXP!*) SXP!*)
	(COPYL (GET SXP!* 'CONJ))
	(AND SXP!* (PUTC2 (CX!?N!* SXP!*) SXP!*)) ))
   ((AND (IDP (CAR SXP!*)) (FACPR (CAR SXP!*)))	% if tsr:
		(CXTSR (CAR SXP!*)) )			% then just change name
   ((CONS (CMPLX (CAR SXP!*)) (CMPLX (CDR SXP!*)))) ))

% CMPLX.SL end
