%:fil STECUP.SL 	Bring STEnsor UP, -on system: C-ambridge U-niv lisp
% Copyright (C) L Hornfeldt

% Fix for the Atari as it doesn't know its current directory.
% This must be changed to agree with the disk name on your Atari. 
%:LH Modify the CURRENTDIR* from SLISP which is eg:  e:/shp/SHPSRC/CULISP
% First part may vary, eg   f:/new/... or just f:/ , and is inherited.
(IFP (EQ 'ATARI (SYSTYPE 'MACHINE))
 (PROGN
  (SETQ X!* (CNDR                                   %  X* :=  (S H P S R C..)
             (SETQ L!* (EXPLODEC CURRENTDIR!*))
             (DIFFERENCE (LENGTH L!*) 13) ))
  (RPLACD X!* (APPEND '(T S) (CDDDR X!*))) % Create (/ S H P / S T S S R C..)
  (WARNINGFT (LIST
   (SETQ CURRENTDIR!* (MAKESTR L!*))
   " = Constructed CURRENTDIR* in STECUP! <<<")) %:UP
  (OR (AND (BOUNDP 'FLOPPY!*) FLOPPY!*)
      (SETQ FLOPPY!* (CAR L!*)) ) ))	% For easy test

(SETQ X!* (SETQ L!* NIL))

% Search list to be used when building stensor only.
(SETQ MSEARCHLIS!* NIL)
(ADDSUBDIRS
 (AND (BOUNDP 'CURRENTDIR!*) CURRENTDIR!* (LIST CURRENTDIR!*))
 '(".." "../.." "../../shplib" "../../sllib" "../../metrics"
%   (("../../slsrc" LISPSYS)) "../../slsrc"
%   (("../../shpsrc" LISPSYS)) "../../shpsrc"
  ) )
%(ADDSUBDIRS NIL LISPLIBDIR!*)		% Lisp library directories
(SETQ MSEARCHLIS!* (CONS NIL MSEARCHLIS!*))

(COND ((GETD 'REDUCE)	(DUMPFILE '!.!.!/!.!.!/rtensor)
			(LOAD STBOOT!.RSH) ))		% JEFS.

(IFP FLOPPY!* (MAPC '(
	"Checklist on atari:
	1: Reboot after last lisprun
	2: Use lisp.PRG (from an image-free floppy),
	   insert SL/SHP-IMAGE-floppy to start up on
			(then SHPSRC/STSSRC to read of course)" "
	      lisp.TTP here, would cause 'module not fnd'
		already for the 1:st module to load after initload!
		Only to create SL, .TTP must be used,
		and to use SHP/STS, .TTP may be used." "
		TOS-parameters: IMAGE=IMAGE LEAVE=80
		-Latter necessary if many nested files are to be used,
		 as in slcup/shpcup with unshortened filestructure." "
	3: (RDF 'B!:!\shpcup!.sl)	(or dito for stecup.sl)
	4: Save on other floppy") 'PRINC))

% due to err ***NARGS given as 5873(000016F1)$macfex (compiled code: 0 args)
%(IFP (GETD 'DM!%) NIL (CPROGN..))	%:tmp Sts on Shp on ms
(IFP (OR (GETD 'DM!%) (NOT (GETD 'AUTOLD))) NIL (CPROGN
	(MOVD 'DM!% 'DM)
	(REMFLAG '(SAMEDEF) 'LOSE)
	(OR (GETD 'REDUCE) (DM!% SAMEDEF LI (LIST	%:red dm confused
	 'DM!%(CAR LI) 'LS (CONS 'CONS (CONS (MKQUOTE(CADR LI)) '(LS)))
	%(DM	cpyfn	LS	 (CONS		'orgfn		LS))
	)))
  ))

%(LOAD DFDM)	% Define DF/DM a la SLisp also in Culisp (Now by basmac)

(REMFLAG '(I1 I2) 'GLOBAL)	% CuFix, in case on Classi,so can mk fluid

(SETQ CULISP!* T)		% Shorter predicate for IFP
(QSET 'DEBUG NIL)		%:UP Preset to T for short loadup
(QSET '!*MODULCOMP T)		% Flag for compilation (unless prev set)
(SETQ !*PWRDS T)		% Print words/time
(IFP T %:tmp (EQUAL 1.08 (SYSTYPE 'LISPVERS))		% but for ORD-bug
     NIL
     (SETQ !*ORD T) )			% Compiled code eval args IN ORDER!

(IFP FLOPPY!* (PROGN			%:ATARI:
  (SETQ !*NOCHECK T)				% no Fchkarg. MEMORYSIZE?
  (SETQ HDSK!* (NOT (EQ FLOPPY!* 'B)))		% Partition B mean: only floppy
	))

(OR	(GETD 'LOAD!%)
	(MOVD 'LOAD!% 'LOAD) )			% Save O-riginal LOAD as LOAD!%

%(CLOAD GCTRAP)
(XPUSH MLIST!* 'SHPMAS)		%:cu Un-necessary file (just for franz)
(NCONC MEXTLIS!* '(STS))

(REMFLAG '(SETQ) 'EVAL)	%:crf Eval SETQs for above initial setups,but not below
%(IFP FLOPPY!* (CAR!-NIL!-LEGAL T))	% As on Orion

(LOAD STEUPV)			% Load basic stensor
(IFP DEBUG NIL (LOAD STEUP))	% (maybe) load also supplements

%(MOVD 'COPYL 'COPY)		%:cu has COPYL=Macro,so COPYI/tedef maps/w COPY
(SHPDEBUG 1)			% 3=Show fns+nbr of args,but not values
(SETQ RATEXFORM T)		%:cu "Rational nbrs into External Form"
% SETQ !*INT
(SETQ NOGRIN T)			%:cu Rabbes GRIND.SL not fully adapted
(OR (GETD 'NOZDO) (LOAD SUMBOU))
(SETQ !*COMP NIL)
(COND ((GETD 'EXCISE)	(VERBOS 6)
			(EXCISE 'LISPCOMP) ))
(SETQ MEXTLIS!* '(STS SL SHP))

(COND
 ((GETD 'REDUCE)				% old STFIN.RSH:
	(SAVEFNDEFS STSCLASH!* 'SHEEP NIL)	% JEFS	Code by Jim Skea for
	(SAVEPLISTS STSCLASH!* 'SHEEP NIL)	% STENSOR load into REDUCE
	(SAVEFNDEFS STSTRAMPLES!* 'SHEEP NIL)
	(SAVEPLISTS STSTRAMPLES!* 'SHEEP NIL)
	(DE STENSOR () (SHEEP))		))

(COND
 (FLOPPY!*
	(RPLACD MLIST!* NIL)			% for economy
	(SETQ MSEARCHLIS!* '(!\STSLIB NIL))	%:tmp Workflpy has librysubdir
	(LINELENGTH 78)
	(OR RESET!* (SETQ RESET!* '(!*ECHO NOMSG)))
	(PUSHQ RESET!*  'FAC)
	(PUSHQ RESETT!* 'EDEF!*)
	(AND (GETD '!%EXC) (PRINCS '!%EXC) (!%EXC))
	(PRINC "Funs %EXF+%PDEFR=%EXC excises module groups")
	(PRINC (LIST "********LOCALs=" (LENGTH LOCALFUNCTIONS!*)))
	%(MAPC LOCALFUNCTIONS!* 'REMOB) (SETQ LOCALFUNCTIONS!* NIL)	%:UP
	))

%(SETQ PROP "Could've added arg(s)_on_same_line")	% Unix/basste

(PROGN
(PRINT (SETQ TOPLEVEL!* 'DWIM))
(COND
 ((NOT FLOPPY!*)
	(AND (BATCHP) (SAVERUN NIL)) )	%:up If not batch,do SAVERUN.. manually
 ((EQ FLOPPY!* 'B)			% On ATARI with JUST FLOPPYDRIVE:
	(SETQ INITFILE!* NIL)		% -Then no stensor.ini
	(PRINC " ATARI /w no hdsk: Setting minimal MEXTLIS* ==")
	(PRINT (SETQ MEXTLIS!* '(SL SHP)))	%:AT	-Minimize extensions!
	(TERPRI)   (RPT 72 '(PRINC "="))
	(PRINCS
	"   Change to STENSOR INI - floppy !!	Then type (Y)")
	(DE Y () (PROGN (REMD 'Y) (SAVERUN NIL)))
	  )	% Cant do saverun from file: cant close file after floppyswap!
 ((SETQ HDSK!* T)		% Atari with hard-disk.  Then is:
	%(SETQ A!:!\ NIL)	% -LISP.TTP on same partition as IMAGE
	(SAVERUN NIL) )
 ) )

% STECUP.SL end
