%:fil PDOCUM.SL 		TOOLS TO CREATE DOCUMENTATION	%:hlp
%				=============================
% SUMMARY:	Give textstrings to PDEF/DECLT, and/or
%		n lines of text after a (DOC n) -command
%		then produce file.doc with (DOCUMENT file)

% A string of text can be included anywhere among the extra arguments to PDEF
% and DECLT. This is a help-string, eg a description of the tensor, which is
% displayed by WDEF together with the actual formula.
% (HELP TSR) only display the string.

% NOMSG switch [off], suppress eg WDEF/DECLT writing of help strings.

% (DOC nbr)	Either skips or writes the next nbr lines.
%	Used in a file to precede nbr lines of documenting text, which
%	then normally is ignored (as if preceeded by %).

% WDOC switch [off] cause (DOC nbr) to Write the next nbr lines
%	instead of ignore them. Temporarily set true within DOCUMENT.

(FLUID '(WDOC HELP!*))		% DOC# HELPON now in PDEFR

% Overwrite the skeleton (for WDOC off) that was defined in PDSYMN:
(DF DOC (L) (COND			%:b If arg: Read so many lines
  (L (RPT(ADD1 (EVAL(CAR L)))	% 1 extra to rid of lf at cmdlne
	 (COND (WDOC '(READTO 10))	% Deflt=skip when loading:
		(T (IFP CULISP!* '(SKIPTO (ASCII 10)) '(zapline))) ) ))
  (T (DOC!# WDOC)) ))		% No arg: read up to next *SHARPSIGN!*


% ********
(IFP (GETD 'EDEF) (CPROGN		% Until end; only STENSOR

(DE CARIF1 (L) (OR (ATOMR L) (AND(CDR L)L) (CAR L))) %:b1 CAR if just 1 element

% PRTELP used where/duty:	DECLT: Nothing, + Help if WDOC and no DEF
%				APRNT: Formula, + Help if WDOC
% Document give a header-line?:
% TSR t = formula	Sym:	Help:	Zeromsg:

(DE PRTELP (TN FO HD)	%:s PRinT TEnsor,def,sym,hELP,zeromsg.
 (PRTLF "%v  %p	%v	%w %w"	% v keeps TXT. If txt,use w/p
	TN				% Fullname
	(OR (AND FO (LIST 'SETEN HD FO))	% If FO: HD=FO, else ""
	    FN)				% To be nam-substituted
	(AND (FCDR (SETQ FO (GET TN 'FACTOR)))	% Prop=((rnk) symop s12..)
	     (COPY (CARIF1 (CADDR FO))) )    % Then give S12 or (S A12 A34) etc
	(CONS 'TXT (COPY (GET TN 'HELP)))	%:b? CONSCOPYGET
	(AND (SETQ TN (GET TN 'ZEROMSG))
	     (LIST 'TXT "If zero:" (COPY TN)) ) ))

% (DOCUMENT file t1 t2..)
% =======================
% Creates a file "file.DOC" containing the output of (WDEF t1 t2..), ie the
% help-string and formula for each tensor. If no tensors t1 t2... were
% specified (normal use),then "file.DEF" will be loaded instead with WPDEF on,
% so WDEF is used on each tensor being defined in that particular .DEF-file.

(DF DOCUMENT (WPDEF) (PROG (SYMB NOMSG WDOC SLEEP)
 (SETQ NOMSG (SETQ WDOC (SETQ SLEEP T)))	% Make TCOMPout sleep
%(SETQ SYMB (CAR WPDEF))
 (SETQ SYMB (CADRDOWN (FILNAM (CAR WPDEF)))) % String into: (Prefix Fil . Ext)
 (EVALCONS 'OUTF	% Variable-name is also flag, thus ON
  (CONS
   (SYMBHANG '!.DOC)	% ".DOC" Nogo PSL 3.2
   (COND
    ((CDR WPDEF) (NCONS (CONS 'WDEF (CDR WPDEF))))
    (T (SETQ MLIST!* (DELQIP SYMB MLIST!*))
       (LIST
	(LIST 'MAPC
	 (MKQUOTE
	  (LIST "****  Documentation of "
		SYMB
		".DEF and .BLF **** "
		(DATETIME)  % Gives TIME or NIL
	 "Full/Short-name:   Formula:	Symmetry:	Comment:"
		))
	 ''PRIN2)
	(LIST 'LOADEF (CAR WPDEF)) )) ) ) ) ))
))
% PDOCUM.SL end
