%:fil PLOT.SL           PLOTTING COMMAND: (PLOT fn var frm to)
(QSET 'PLOTNUM 100)                      % (PLOT != ...) to SHEEP-read fn
(QSET 'SCALE 600)                       % (PLOT !< ...) to STENSOR-read fn
(FLUID '(PLOTNUM SCALE DEBUG))
(LINELENGTH 78)
(SHPDEBUG 4)(verbos 6)

(DF PLOT (DI) (PROG (FN A V I J X Y YMIN YMAX)
  (SETQ FN (SUBST 'X!* (CADR DI)
    (COND ((EQCARE DI '!=)  (LIST 'SSIMP (FOIN)))
          ((EQCARE DI '!<)  (EVALIST 'LMFAC
				(LIST 'SSIMP (MKQUOTE (REASUF))) ))
          (T    (CAR DI)) ) ))
  (SETQ A (CADDR DI))
  (SETQ DI (FLOAT (DIFFERENCE (CADDDR DI) A)))                  % Arg interval
  (SETQ PLOTV (SETQ V (mkvect (ITIMES2 2 PLOTNUM))))
  (SETQ I (SETQ J 0))
        %             i
        % X  = A + ------- (B - A)
        %  i       PLOTNUM
        % Raster =   -'-   * 640
  (SETQ YMAX (MINUS (SETQ YMIN 99999)))
  (AND DEBUG (BREAK0))
L (COND
   ((ILESSP I PLOTNUM)
        (SETQ X!*     (PLUS2 A (QUOTIENT (TIMES2 I DI) PLOTNUM)))  % x-arg
        (PUTV V J (PLUS2 2(FIX (QUOTIENT (TIMES2 I 638) PLOTNUM)))) % x raster
%       (PUTV V J                       (FIX (TIMES2 X* SCALE)))
%       (PUTV V (IADD1 J)               (FIX (TIMES2 (SSIMP(EVAL FN)) SCALE)))
        (PUTV V (SETQ J (IADD1 J))      (SETQ Y (EVAL FN)) )     % Val
        (SETQ J (IADD1 J))
        (SETQ I (IADD1 I))
        (SETQ YMIN (MIN2 YMIN Y))
        (SETQ YMAX (MAX2 YMAX Y))
        (GO L) ) )
  (SETQ YSCALE (MINUS (QUOTIENT 190.0    % So SCALE*ABSMAX = 200 pixel =scrnbrd
        (MAX2 (ABS YMAX) (ABS YMIN)) ))) % Largest distance from Xaxis=amplitud
  (AND DEBUG (BREAK0))
  (SETQ I (SETQ J 0))
N (COND                                 % Having found yscale, mult it in:
   ((ILESSP I PLOTNUM)
        (PUTV V (SETQ J (IADD1 J))
                (FIX (PLUS2 200 (TIMES2 (GETV V J) YSCALE))) )        % Coord
        (SETQ J (IADD1 J))
        (SETQ I (IADD1 I))
        (GO N) ) )
  (v!_pline handle   2 '[2,200,639,200])                % x-axis
  (v!_pmarker handle 2 '[2,209,200,209,400,209])        % dito marks
  (v!_pline handle   2 '[2,0,2,400])                    % y-axis
  (v!_pline handle PLOTNUM V)                   % V=Vector [x1,y1, x2,y2, ...]
  (vs!_curaddress handle 1 6)
  (PRINC (LIST YMIN YMAX))
  (vst!_effects handle 17)
  (v!_gtext handle 300 370 (ltoc "Plot"))
  ))

(setq ini '(progn
(aes!-init)
(vdi!-init)
(appl!_init)
(setq handle (graf!_handle charh charw boxh boxw))
(setq work!_out (mkvect 56))
(v!_opnvwk '[1,1,1,1,1,1,1,1,1,1,2] handle work!_out)  ))

(SETQ SI '(PLOT (EXPT (SIN X) 2) X 0 3.14))

(PRINC "Ensure LISPGEM is available, and type DO<return>")
(ADDO (EVAL INI) (EVAL SI))

% PLOT.SL end
