%:fil TSRTRE.SL 	TRigs from Exponentials (experimental)
%
%    s2 ______  sc _____ c2
%	`     /	  `     /		2 Tethraedrons
%        `` //     ``  //
%	  se _______ ce
%	    `       /		Tethraedron
%	     ``	  //
%               1e  
%
% The e refer to a e^+x above the sin-cos plane, and a e^-x below.
% These exponentials combine:
%	if added to cos (up right):	e^x + e^-x = 2cosh x
%	if subtrctd to sin (up left):	e^x - e^-x = 2sinh x
% Thus in addition to the trigrelation s2+c2=1 treated in TSRTR that relate
% terms in a large top-down triangle s2-c2-1 in the papers plane, 
% we now in addition have smaller tethraedrons with two corners in that plane,
% and two on opposite sides of it (the exponential terms).
% Eg above and below "1" are quorners e^+ and e^-,
% related to s (sinh) and c (cosh).
% 
% First a simple solution: Transfer all e to trigh
% (later might need sumsubs back)

(ON FACTRIG)	(SFACTOR EXP)
(OR (GETD 'ADTNL) (DE ADTNL (X) (XPUSH TENL X)))

(PUT 'EXP 'REAFAC (LIST 'LAMBDA '(H)	% (H)=!%!*FN in PDEFR
  '(ADTNL (COND
     ((EQCAR H '!%)
		(LIST 'EXP (REAIA H)) )	% If given as <EXP IX>
     (T	(LIST 'EXP (COND
		(MISBL (MKTIMS MISBL H))
		(T H) ) ))		% E^Z =(EXPT (EXP 1) Z), Z in MISBL
	)) ))				% (EQUAL H '(EXP 1))

(COND ((NOT (GETD 'TRIGSUM3))
		(REMPROPL '(SINCOS SINCOH) 'TSUL)
		(LOAD TSRTR) ))
(HNGIR 'SINCOS 'TSUL '(NEGSCARG (CDADR !*RTNL) INDX15))
(HNGIR 'SINCOS 'TSUL '(SPF1!^!^ INDX14 INDX15 INDX16))
(HNGIR 'SINCOH 'TSUL '(NEGSCARG (CDADR !*RTNL) INDX15))
(HNGIR 'SINCOH 'TSUL '(SPF1!^!^ INDX14 INDX15 INDX16))

% NEG SinCosARGument sin x ^p cos x ^q
(DE NEGSCARG (XPQ P) (PROG (C)
 (SETQ C (CAR XPQ))
 (RETURN (COND	% XPQ=(X P Q)
  ((AZEROP C) (COND
	((AZEROP P) (CT!*RT))	% Sin^0(0)=1,rest is cos(0) give 1
	((MINUSP P) (WARNINGL
430 "DIVISION BY SIN 0 = ZERO !!??"	%:war
%:w	Reconsider your input; there occured a sin(0) raised to a negative
%:w	power, ie you have requested division by zero!?
%:w	 Trying to continue though, at users responsibility.#
%:w
	 ))
	(T	(CTZRO)) ))	% Sin 0 = 0, cut
  ((ATOM C) NIL)
  ((NOT (EQCARE C TIM!*)) NIL)
  ((SMMINUSP C)
	(RPLACA XPQ (SMMINUS C))
	(OR (EVENP P) (SP!&SC -1)) )	% sin^3 (-x).. = -sin^3(x)..
	% In any case return NON-nil,so rerun,while composed arg
  ((EQCAR (CDR C) 'I) % sin(ix)=i sinh(x) and sinh(ix)=i sin(x).Cos/cosh no i
	(RPLACA XPQ (CADDR C))		% Remove i from arg, turn (* i x) to x
	(SETQ C (EQ 'SINCOH (CAADR !*RTNL)))	% Hyperbolic case?
%	(RPT '(SP!&SC 'I) P)	% i out of arg of sin or sinh gives i-factor-
	(SP!&SC (SMEXPT 'I P))	% -for each sin-power P. Nothing for cos
	(RPLACA(CADR !*RTNL) (IFPE C 'SINCOS 'SINCOH))% Trn sincos>sincosh vv
	) )) ))

%(DE RMINU (XPQ) (AND	..	% ReMove MINUs-sign. Predicate
%  (RPLACA XPQ (SMMINUS (CAR XPQ))) ))

% Need to give mask as tensor, so X seen as index, so wild, not literal match:

(SETSUB TSUL) <EXP X> $		<SINCOH X 1 0> + <SINCOH X 0 1> $
%(PRT '(SINCOS X 1 0))	(PRT '(SINCOS X 0 1))	(PRT '(SINCOS X 1 2))
% TSRTRE.SL end
