%:fil (WTERMS tsr)	Write the number of TERMS in each tensor component%:hlp
%:h Takes tensor-specifications as args (in same way as MAKE and other TENVALs)
%:h	-and W-rites the number of TERMS that each tensor component contains,
%:h	-or if just ONE term, the type of the term is indicated.

%:h Example: (WTERMS RIC FROM 0 2 TO 2 3) -might cause the following-
%	     ===========		=
%:   -row-by-row output:	-shows that the specific component contains:

%: ((RIC 0 2) PLUS . 97)	- *** a SUM of 97 TERMS ***  This is the usual.
%:				Let us suppose the remaining components did NOT
%:				contain sums. Then instead of PLUS, some other
%:				symbol is used,telling that the single term is:
%: ((RIC 0 3) TIMES . 9)	-a product of 9 factors, or only
%: ((RIC 1 2) EXPT . 2)		-an EXPonenTial, sin, cos etc(with n args), or
%: ((RIC 1 3) 64)		-simply an "atom": then entire value is shown
%: ((RIC 2 3) 9 . 17)		-also when value was a RATIONAL number(9/17)

%:	(ON NOZERO)		-exclude zero-components from being listed.

% Used to eg:
%	-Obtain an instant overview of the computational COMPLEXITY.
%	-Compare results,to find OPTIMAL combination of multiple SUBSTITUTIONS.
%	-Forecast computability of the next object. The hard way to know,is to
%			waste cpu-days, just to finally find memory exhausted.
%			A "nogo" lets you know that further action is worthwile
%			eg economize by "kernalizing". See SETSUBFOR in SHPSUB.

(IFP(AND (EQ 'CULISP (SYSTYPE 'LISPSYSTEM))
	 (NOT (GETD 'DECLT)) )
    (LOAD DFDM) )
(PUSHQ MEXTLIS!* 'STS)
(IFP (GETD 'CDRIF) NIL (LOAD BASFUN))

(FLUID '(LINITFN!* ALLMSG AUTOLOSDEP
	 MTERMS CRELM))		% Latter may be simply global.

(SETQ MTERMS T) %:h Cause io_M_ake write TERMS (since this loaded anyway)

(DF WTERMS (L)
 (PROG (LINITFN!* ALLMSG AUTOLOSDEP)	% No msg each comp. No loss of dep tsrs
  (SETQ LINITFN!* 'PSTRUC)	% DO (LINIT RIE) -to:
  (RETURN (EVALCONS 'LINIT L)) ))

(DE STRUC (XP) (OR	%:b Return STRUCture of single arg eXPr/WTERMS,SPY
 (ATOMR XP)
 (CONSCAR XP
   (OR	(ATOMR (CDR XP))
	(LENGTH (COND
	 ((EQ (CAR XP) 'ALG) (CDDDR XP))
	 (T	(CDR XP)) )) ) ) ))

%:b (PSTRUC X)	 Print: (X . STRUCture of global CRELM) Eg tsr, in WTERMS
%			X:tensor-spec		CRELM:expr	Returns:CRELM
(DE PSTRUC (X) (PROGN
  (OR	(AND (NUMBERP CRELM) NOZERO (ZEROP CRELM))	% Depress zero?
	(PRINT (CONS X (STRUC CRELM))) )
  CRELM))			% and return original value

%:hlp	(SUMSPY) causes size-info be displayed while computing components-
%:hlp	-at least for tensor-bulfs that have been made by TCOMPing!
(DF SUMSPY (L)
	%(MOVD 'SMPLUS2 '!%SUMSPY)	% Don't: Affects + in g*(RIE + RIE)
	(DE ADANZ (X) (SETQ ANS!* (!%SUMSPY X ANS!*))) )

(MOVD '!%SMPLUS2 'SMPLUS2)	% Just backup. Normally dont change SMPLUS2.

(DE !%SUMSPY (X Y) (PROGN
  (MAPC (LIST " Merging " (STRUC X) " into " (STRUC Y) " giving.. ")
	'PRINC)		%:b?	MAPRIN on a list?
  (PRINTC (STRUC (SETQ Y (!%SMPLUS2 X Y))))
  Y))

% (SPLIS) (SPLISO) CTEN!* CRINDX!$ TENVALVALUE!$ LATEN!* LTNARG!* TN!&
% WTERMS.SL end
